#include <string.h>
#include "CryptoFdSerial.h"

/* cryto elements by Ryan Clarke (1o57) */ 

CryptoFdSerial::CryptoFdSerial()
{
}

CryptoFdSerial::CryptoFdSerial(int rxpin, int txpin, int mode, int baudrate)
{
    FdSerial(rxpin, txpin, mode, baudrate);
}

void CryptoFdSerial::caesar(const char *p_zstr)
{
  int c, lost, count;

  lost = *p_zstr++;
  count = strlen(p_zstr);
  while (--count >= 0) {
    c = *p_zstr++;
    switch (c) {
      case 32: tx(32); break;
      case 13: tx(13); break;
      default: tx((((c-65)+26-lost)%26)+65); break;
    }
  }
}

void CryptoFdSerial::exor(const char *p_zstr)
{
  int lost, count;

  lost = *p_zstr++;
  count = strlen(p_zstr);
  while (--count >= 0)
    tx(*p_zstr++^lost);
}
    
void CryptoFdSerial::otp(const char *p_zstr1, const char *p_zstr2)
{

  while (*p_zstr1 != 0) {
    if (*p_zstr1 == 32) {
      tx(32);
      p_zstr1++;
    }
      
    else if (*p_zstr1 == 13) {
      tx(13);
      p_zstr1++;
    }
      
    else if (*p_zstr2 == 32) {
      p_zstr2++;
    }
      
    else {
      tx((((*p_zstr1++-65)+(*p_zstr2++-65))%26)+65);
    }
  }
}
